from pysqlite2 import dbapi2 as sqlite
import gzip
import string

# orthology file from wormMart WS150
orthologyFile = '/proj/genome/download/cecbOrtho.txt'
geneInfoFile = '/proj/genome/download/gene_info'
cbGeneDB = '/proj/genome/C_briggsae/cbriggsae.genedb'
ceGeneDB = '/proj/genome/C_elegans/celegans.genedb'
homoloDB = 'homologene.db'

geneFile = open(geneInfoFile,'r')
orthoFile = open(orthologyFile, 'r')

syn2locus = {}
locus2syn = {}
ce2cb = {}
cbList = []
ceList = []

print "getting cbList and ceList"
db = sqlite.connect(cbGeneDB)
sql = db.cursor()
sql.execute('select distinct name from gene_entries')
res = sql.fetchall()
db.close()
for entry in res:
	cbList.append(entry[0])

db = sqlite.connect(ceGeneDB)
sql = db.cursor()
sql.execute('select distinct name from gene_entries')
res = sql.fetchall()
db.close()
for entry in res:
	ceList.append(entry[0])

print "reading synonyms from gene_info"
for line in geneFile:
	field = line.split('\t')
	if field[0] != '6239':
		continue
	locus = field[1]
	synonyms = field[4].split('|')
	goodSynonyms = []
	for entry in synonyms:
		if entry in ceList:
			goodSynonyms.append(entry)
			syn2locus[entry] = locus
		elif entry[:-1] in ceList:
			goodSynonyms.append(entry)
			syn2locus[entry[:-1]] = locus
	locus2syn[locus] = goodSynonyms

geneFile.close()
print "len(syn2locus) = %d " % len(syn2locus)
print "len(locus2syn) = %d " % len(locus2syn)

print "building orthoFile"
for line in orthoFile:
	field = line.split()
	try:
		ceLocus = field[0]
		cbLocus = field[1].strip()
		if ceLocus[-1] in string.letters:
			ceLocus = ceLocus[:-1]
		ce2cb[ceLocus] = cbLocus
	except:
		print 'could not process %s' % line
orthoFile.close()
print "len(ce2cb) = %d" % len(ce2cb)

db = sqlite.connect(homoloDB)
sql = db.cursor()

sql.execute('select * from homolog where genome = "celegans" ')
results = sql.fetchall()

print "Updating %d entries in homolog table" % len(results)
for entry in results:
	(rowID, hID, genome, gID) = entry
	try:
		syns = locus2syn[gID]
	except:
		print "could not find %s " % gID
		continue
	
	newGID = ''
	for candidate in syns:
		if candidate in ce2cb:
			newGID = candidate
	if newGID == '':
		for candidate in syns:
			if candidate in ceList:
				newGID = candidate
	else:
		sql.execute('insert into homolog(ID, homoloID, genome, gID) values (NULL, "%s", "cbriggsae", "%s") ' % (hID, ce2cb[newGID]))
		del ce2cb[newGID]
	
	if newGID != '':
		sql.execute('update homolog set gID = "%s" where ID = %d' % (newGID, rowID))

#sql.execute('select homoloID from homolog order by homoloID')
#ids = sql.fetchall()
#realIDs = []
#for strID in ids:
#	realIDs.append(int(strID[0]))
#realIDs.sort
#topHID = realIDs[-1]
topHID = 0

print "Adding %d new ce2cb entries" % len(ce2cb)
for ceLocus in ce2cb:
	topHID += 1
	sql.execute('insert into homolog(ID, homoloID, genome, gID) values (NULL, "%s", "celegans", "%s") ' % ( 'cecb' + str(topHID), ceLocus))
	sql.execute('insert into homolog(ID, homoloID, genome, gID) values (NULL, "%s", "cbriggsae", "%s") ' % ('cecb' + str(topHID), ce2cb[ceLocus]))

db.commit()
sql.close()
db.close()

