import sqlite
import gzip

locusLinkFile = '/proj/genome/download/bdgpToLocusLink.txt'
homoloDB = 'homologene.db'

locusLink = open(locusLinkFile, 'r')

syn2locus = {}
locus2syn = {}
dmList = []

print "reading locusLink names for genes"
for line in locusLink:
	field = line.split('\t')
	locus = field[1].strip()
	(gID, ver) = field[0].split('-R')
	locus2syn[locus] = gID

print "len(locus2syn) = %d " % len(locus2syn)

db = sqlite.connect(homoloDB)
sql = db.cursor()

sql.execute('select * from homolog where genome = "dmelanogaster" ')
results = sql.fetchall()

print "Updating %d entries in homolog table" % len(results)
for entry in results:
	(rowID, hID, genome, oldgID) = entry
	newgID = ''
	try:
		newgID = locus2syn[oldgID]
	except:
		print "could not find %s " % oldgID
		continue
	
	if newgID != '':
		sql.execute('update homolog set gID = "%s" where ID = %d' % (newgID, rowID))

db.commit()
db.close()

