import sqlite

inFile = open('gene_info')

lines = inFile.readlines()
inFile.close()

db = sqlite.connect('gene_info.db')
cursor = db.cursor()

cursor.execute('create table gene_info(ID INTEGER PRIMARY KEY, genome varchar, gID varchar, symbol varchar, locustag varchar, dbxrefs varchar, chromosome varchar, map_location varchar)')
cursor.execute('create table gene_description(ID INTEGER PRIMARY KEY, genome varchar, gID varchar, description varchar)')
cursor.execute('create table gene_synonyms(ID INTEGER PRIMARY KEY, genome varchar, gID varchar, synonym varchar)')

genomeDict = {'9606':'human', '6239':'celegans', '10090':'mouse','10116':'rat',
'7227':'dmelanogaster', '4896':'pombe', '4932':'yeast', '5141':'neurospora', 
'3702':'arabidopsis', '9031':'chicken', '9615':'dog', '9598':'chimpanzee'}
genomeKeys = genomeDict.keys()

for line in lines:
	doInsert = False
	field = line.split('\t')
	if field[0] in genomeKeys:
		try:
			genome = genomeDict[field[0]]
			sqlstmt = "INSERT into gene_info(ID, genome, gID, symbol, locustag, dbxrefs, chromosome, map_location) values (NULL, '%s', '%s', '%s', '%s', '%s', '%s', '%s')" % (genome, field[1], field[2], field[3], field[5], field[6], field[7])
			cursor.execute(sqlstmt)
			#print sqlstmt
			
			descr = field[8].strip()
			if len(descr) > 1:
				sqlstmt2 = 'INSERT into gene_description(ID, genome, gID, description) values (NULL, "%s", "%s", "%s")' % (genome, field[1], field[8].strip())
				cursor.execute(sqlstmt2)
				#print sqlstmt2

			sqlstmt3 = "INSERT into gene_synonyms(ID, genome, gID, synonym) values (NULL, '%s', '%s', '%s')" % (genome, field[1], field[1].strip())
			cursor.execute(sqlstmt3)

			synonyms = field[4].split('|')
			for entry in synonyms:
				try:
					if entry != '-' and entry != field[1].strip():
						sqlstmt3 = "INSERT into gene_synonyms(ID, genome, gID, synonym) values (NULL, '%s', '%s', '%s')" % (genome, field[1], entry.strip())
						cursor.execute(sqlstmt3)
						#print sqlstmt3
				except:
					pass
		except:
			print 'could not register %s' % (line)

cursor.execute('create index genIdx1 on gene_info(genome)')
cursor.execute('create index genIdx2 on gene_description(genome)')
cursor.execute('create index genIdx3 on gene_synonyms(genome)')

cursor.execute('create index gIDIdx1 on gene_info(gID)')
cursor.execute('create index gIDIdx2 on gene_description(gID)')
cursor.execute('create index gIDIdx3 on gene_synonyms(gID)')

cursor.execute('create index synIdx on gene_synonyms(synonym)')

db.commit()
db.close()
